Ribbon in EJ2 JavaScript Spreadsheet control

6 Jan 202513 minutes to read

It helps to organize a spreadsheet’s features into a series of tabs. By clicking the expand or collapse icon, you can expand or collapse the ribbon toolbar dynamically.

Ribbon Customization

You can customize the ribbon using the following methods,

Method Action
hideRibbonTabs Used to show or hide the existing ribbon tabs.
enableRibbonTabs Used to enable or disable the existing ribbon tabs.
addRibbonTabs Used to add custom ribbon tabs.
hideToolbarItems Used to show or hide the existing ribbon toolbar items.
enableToolbarItems Used to enable or disable the specified toolbar items.
addToolbarItems Used to add the custom items in ribbon toolbar.
hideFileMenuItems Used to show or hide the ribbon file menu items.
enableFileMenuItems Used to enable or disable file menu items.
addFileMenuItems Used to add custom file menu items.

The following code example shows the usage of ribbon customization.

ej.base.enableRipple(true);

var columns = [{ width: 180 }, { width: 130 }, { width: 130 }, { width: 180 }, { width: 130 }, { width: 120 }];

var sheets = [{ ranges: [{ dataSource: data }], columns: columns }];

var spreadsheet = new ej.spreadsheet.Spreadsheet({
    sheets: sheets,
    created: function () {
        spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:F1');
        // Hiding the `Insert` from ribbon.
        spreadsheet.hideRibbonTabs(['Insert']);
        // Set diabled state to `View` ribbon tab.
        spreadsheet.enableRibbonTabs(['View'], false);
        // Adding the `Help` ribbon tab at the last index.
        // Specify the ribbon tab header text in last optional argument(`insertBefore`) for inserting new tab before any existing tab.
        spreadsheet.addRibbonTabs([{ header: { text: 'Help' }, content: [{ text: 'Feedback', tooltipText: 'Feedback',
            click: function (args) { /* Any click action for this toolbar item will come here. */ } }] }]);
        // Hiding the unwanted toobar items from `Home` by specifying its index.
        spreadsheet.hideToolbarItems('Home', [0, 1, 2, 4, 14, 15, 21, 24]);
        // Set diable state to `Underline`, 'Wrap text` toobar items from `Home` by specifying the item id.
        spreadsheet.enableToolbarItems('Home', [`${spreadsheet.element.id}_underline`, `${spreadsheet.element.id}_wrap`], false);
        // Set diable state to `Protect Sheet` toolbar item from `Data` by mentioning its index.
        spreadsheet.enableToolbarItems('Data', [0], false);
        // Adding the new `Custom Formulas` toolbar item under `Formulas` tab for adding custom formulas. 
        spreadsheet.addToolbarItems(
            'Formulas', [{ type: 'Separator' }, {
                text: 'Custom Formulas', tooltipText: 'Custom Formulas',
                // You can set click handler for each new custom toolbar item
                click: function (args) {
                    // You can add custom formualas here.
                }
            }]);
        // Adding new custom item `Import` after the existing `Open` item. By default, new item will add after the specified item.
        spreadsheet.addFileMenuItems([{ text: 'Import', iconCss: 'e-open e-icons' }], 'Open');
        // Adding new custom item `Export As` after the existing `Save As` item.
        // Set `insertAfter` optional argument as `false` for adding new item before the specified item.
        spreadsheet.addFileMenuItems(
            [{
                text: 'Export As', iconCss: 'e-save e-icons', items: [{ text: 'XLSX', iconCss: 'e-xlsx e-icons' },
                    { text: 'XLS', iconCss: 'e-xls e-icons' }, { text: 'CSV', iconCss: 'e-csv e-icons' }]
            }],
            'Save As', false);
        // Adding the new `custom dropdown button` in the ribbon toolbar item under the `Data` tab for adding a custom dropdown button using the addToolbarItems method in the spreadsheet ribbon.
        spreadsheet.addToolbarItems('Data', [{ type: 'Separator' }, { id: 'custombtn', tooltipText: 'Custom Btn', template: appendDropdownBtn('custombtn') }], 7);
    },
    fileMenuBeforeOpen: function () {
        // Since the file menu items are created dynamically, so need to perform the hide/show and enable/disable operations
        // under filemenu before open event.
        // Hiding the `Save As` and `Open` item.
        spreadsheet.hideFileMenuItems(['Save As', 'Open']);
        // Set diable state to `New` item. You can perform any file menu items customization by specifying the item id,
        // if it has more than one same item text. Set the last argument `isUniqueId` as true for using the item id.
        spreadsheet.enableFileMenuItems([`${spreadsheet.element.id}_New`], false, true);
    },
    fileMenuItemSelect: function (args) {
        // Custom file menu items select handler
        switch (args.item.text) {
            case 'Import': select(`#${spreadsheet.element.id}_fileUpload`, spreadsheet.element).click();
                break;
            case 'XLSX': spreadsheet.save({ saveType: 'Xlsx' });
                break;
            case 'XLS': spreadsheet.save({ saveType: 'Xls' });
                break;
            case 'CSV': spreadsheet.save({ saveType: 'Csv' });
                break;
        }
    },
    openUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/open',
    saveUrl: 'https://services.syncfusion.com/js/production/api/spreadsheet/save',
    // Removed the unwanted support for this samples
    showFormulaBar: false, showSheetTabs: false, allowInsert: false, allowDelete: false, allowMerge: false
});

spreadsheet.appendTo('#spreadsheet');

function appendDropdownBtn(id) {
    let ddlItems = [
        {
            text: 'Download Excel',
        },
        {
            text: 'Download CSV',
        },
    ];
    let btnObj = new ej.splitbuttons.DropDownButton({
        items: ddlItems,
        content: 'Download',
        iconCss: 'e-icons e-download',
        select: function (args) {
            alert(args.item.text + ' clicked');
        },
    });
    btnObj.appendTo(ej.base.createElement('button', { id: id }));
    return btnObj.element;
}
<!DOCTYPE html><html lang="en"><head>
        <title>EJ2 SpreadSheet</title>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <meta name="description" content="Typescript UI Controls">
        <meta name="author" content="Syncfusion">
        <link rel="shortcut icon" href="resources/favicon.ico">
        <link href="https://maxcdn.bootstrapcdn.com/bootstrap/3.3.7/css/bootstrap.min.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-base/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-inputs/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-buttons/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-splitbuttons/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-lists/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-navigations/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-popups/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-dropdowns/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-grids/styles/material.css" rel="stylesheet">
        <link href="https://cdn.syncfusion.com/ej2/29.2.4/ej2-spreadsheet/styles/material.css" rel="stylesheet">
        <link href="styles.css" rel="stylesheet">
        
        <script src="https://cdnjs.cloudflare.com/ajax/libs/core-js/2.4.1/shim.min.js"></script>
        <script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/29.2.4/dist/ej2.min.js" type="text/javascript"></script>
<script src="es5-datasource.js" type="text/javascript"></script>
<script src="https://cdn.syncfusion.com/ej2/syncfusion-helper.js" type ="text/javascript"></script>
</head>

<body>
        <!--Element which is going to render-->
        
        <div id="container">
                <div id="spreadsheet"></div>
        </div>


<script>
var ele = document.getElementById('container');
if(ele) {
  ele.style.visibility = "visible";
}   
      </script>
<script src="index.js" type="text/javascript"></script>
</body></html>

See Also

Ribbon in Angular Spreadsheet component

16 Jun 202312 minutes to read

It helps to organize a spreadsheet’s features into a series of tabs. By clicking the expand or collapse icon, you can expand or collapse the ribbon toolbar dynamically.

Ribbon Customization

You can customize the ribbon using the following methods,

Method Action
hideRibbonTabs Used to show or hide the existing ribbon tabs.
enableRibbonTabs Used to enable or disable the existing ribbon tabs.
addRibbonTabs Used to add custom ribbon tabs.
hideToolbarItems Used to show or hide the existing ribbon toolbar items.
enableToolbarItems Used to enable or disable the specified toolbar items.
addToolbarItems Used to add the custom items in ribbon toolbar.
hideFileMenuItems Used to show or hide the ribbon file menu items.
enableFileMenuItems Used to enable or disable file menu items.
addFileMenuItems Used to add custom file menu items.

The following code example shows the usage of ribbon customization.

import { Component, ViewChild } from '@angular/core';
import { SpreadsheetComponent, MenuSelectEventArgs } from '@syncfusion/ej2-angular-spreadsheet';
import { select } from '@syncfusion/ej2-base';
import { ClickEventArgs } from '@syncfusion/ej2-navigations';
import { dataSource } from './datasource';

@Component({
    selector: 'app-container',
    template: `<ejs-spreadsheet #spreadsheet (created)="created()" (fileMenuBeforeOpen)="fileMenuBeforeOpen()"
                (fileMenuItemSelect)="fileMenuItemSelect($event)" [openUrl]="openUrl" [saveUrl]="saveUrl" [showFormulaBar]="false" [showSheetTabs]="false" [allowInsert]="false" [allowDelete]="false" [allowMerge]="false">
                <e-sheets>
                  <e-sheet>
                    <e-ranges>
                      <e-range [dataSource]="data"></e-range>
                    </e-ranges>
                    <e-columns>
                      <e-column [width]=180></e-column>
                      <e-column [width]=130></e-column>
                      <e-column [width]=130></e-column>
                      <e-column [width]=180></e-column>
                      <e-column [width]=130></e-column>
                      <e-column [width]=120></e-column>
                    </e-columns>
                  </e-sheet>
                </e-sheets>
              </ejs-spreadsheet>`
})
export class AppComponent {
    @ViewChild('spreadsheet')
    spreadsheetObj: SpreadsheetComponent | undefined;

    data: object[] = dataSource;
    openUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/open';
    saveUrl = 'https://services.syncfusion.com/angular/production/api/spreadsheet/save';

    created() {
        this.spreadsheetObj!.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:F1');
        // Hiding the `Insert` from ribbon.
        this.spreadsheetObj!.hideRibbonTabs(['Insert']);
        // Set disabled state to `View` ribbon tab.
        this.spreadsheetObj!.enableRibbonTabs(['View'], false);
        /// Adding the `Help` ribbon tab at the last index.
        // Specify the ribbon tab header text in last optional argument(`insertBefore`) for inserting new tab before any existing tab.
        this.spreadsheetObj!.addRibbonTabs([{ header: { text: 'Help' }, content: [{ text: 'Feedback', tooltipText: 'Feedback',
            click: (args: ClickEventArgs): void => { /* Any click action for this toolbar item will come here. */ } }] }]);
        // Hiding the unwanted toobar items from `Home` by specifying its index.
        this.spreadsheetObj!.hideToolbarItems('Home', [0, 1, 2, 4, 14, 15, 21, 24]);
        // Set diable state to `Underline`, 'Wrap text` toobar items from `Home` by specifying the item id.
        this.spreadsheetObj!.enableToolbarItems(
            'Home', [`${this.spreadsheetObj!.element.id}_underline`, `${this.spreadsheetObj!.element.id}_wrap`], false);
        // Set disable state to `Protect Sheet` toolbar item from `Data` by mentioning its index.
        this.spreadsheetObj!.enableToolbarItems('Data', [0], false);
        // Adding the new `Custom Formulas` toolbar item under `Formulas` tab for adding custom formulas.
        this.spreadsheetObj!.addToolbarItems(
            'Formulas', [{ type: 'Separator' }, {
                text: 'Custom Formulas', tooltipText: 'Custom Formulas',
                // You can set click handler for each new custom toolbar item
                click: (args: ClickEventArgs): void => {
                    // You can add custom formualas here.
                }
            }]);
        // Adding new custom item `Import` after the existing `Open` item. By default, new item will add after the specified item.
        this.spreadsheetObj!.addFileMenuItems([{ text: 'Import', iconCss: 'e-open e-icons' }], 'Open');
        // Adding new custom item `Export As` after the existing `Save As` item.
        // Set `insertAfter` optional argument as `false` for adding new item before the specified item.
        this.spreadsheetObj!.addFileMenuItems(
            [{
                text: 'Export As', iconCss: 'e-save e-icons', items: [{ text: 'XLSX', iconCss: 'e-xlsx e-icons' },
                    { text: 'XLS', iconCss: 'e-xls e-icons' }, { text: 'CSV', iconCss: 'e-csv e-icons' }]
            }],
            'Save As', false);
    }

    fileMenuBeforeOpen (): void {
        // Because the file menu items are created dynamically, you need to perform the hide or show and enable/disable operations
        // under filemenu before open event.
        // Hiding the `Save As` and `Open` item.
        this.spreadsheetObj!.hideFileMenuItems(['Save As', 'Open']);
         // Set disable state to `New` item. You can perform any file menu items customization by specifying the item id,
        // if it has more than one same item text. Set the last argument `isUniqueId` as true for using the item id.
        this.spreadsheetObj!.enableFileMenuItems([`${this.spreadsheetObj!.element.id}_New`], false, true);
    }

    fileMenuItemSelect (args: MenuSelectEventArgs): void {
        // Custom file menu items select handler
        switch (args.item.text) {
            case 'Import': select(`#${this.spreadsheetObj!.element.id}_fileUpload`, this.spreadsheetObj!.element).click();
                break;
            case 'XLSX': this.spreadsheetObj!.save({ saveType: 'Xlsx' });
                break;
            case 'XLS': this.spreadsheetObj!.save({ saveType: 'Xls' });
                break;
            case 'CSV': this.spreadsheetObj!.save({ saveType: 'Csv' });
                break;
      }
    }
}
import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { SpreadsheetAllModule } from '@syncfusion/ej2-angular-spreadsheet';
import { AppComponent } from './app.component';

/**
 * Module
 */
@NgModule({
    imports: [
        BrowserModule,
        SpreadsheetAllModule
    ],
    declarations: [AppComponent],
    bootstrap: [AppComponent]
})
export class AppModule { }
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { enableProdMode } from '@angular/core';
import { AppModule } from './app.module';

enableProdMode();
platformBrowserDynamic().bootstrapModule(AppModule);

Note

You can refer to our Angular Spreadsheet feature tour page for its groundbreaking feature representations. You can also explore our Angular Spreadsheet example to knows how to present and manipulate data.

See Also

Ribbon in React Spreadsheet component

14 Apr 202324 minutes to read

It helps to organize a spreadsheet’s features into a series of tabs. By clicking the expand or collapse icon, you can expand or collapse the ribbon toolbar dynamically.

Ribbon Customization

You can customize the ribbon using the following methods,

Method Action
hideRibbonTabs Used to show or hide the existing ribbon tabs.
enableRibbonTabs Used to enable or disable the existing ribbon tabs.
addRibbonTabs Used to add custom ribbon tabs.
hideToolbarItems Used to show or hide the existing ribbon toolbar items.
enableToolbarItems Used to enable or disable the specified toolbar items.
addToolbarItems Used to add the custom items in ribbon toolbar.
hideFileMenuItems Used to show or hide the ribbon file menu items.
enableFileMenuItems Used to enable or disable file menu items.
addFileMenuItems Used to add custom file menu items.

The following code example shows the usage of ribbon customization.

import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RangeDirective, ColumnsDirective, ColumnDirective } from '@syncfusion/ej2-react-spreadsheet';
import { select } from '@syncfusion/ej2-base';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef(null);
    React.useEffect(() => {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:F1');
            // Hiding the `Insert` from ribbon.
            spreadsheet.hideRibbonTabs(['Insert']);
            // Set disabled state to `View` ribbon tab.
            spreadsheet.enableRibbonTabs(['View'], false);
            // Adding the `Help` ribbon tab at the last index.
            // Specify the ribbon tab header text in last optional argument(`insertBefore`) for inserting new tab before any existing tab.
            spreadsheet.addRibbonTabs([{
                header: { text: 'Help' }, content: [{
                    text: 'Feedback', tooltipText: 'Feedback',
                    click: () => { /* Any click action for this toolbar item will come here. */ }
                }]
            }]);
            // Hiding the unwanted toolbar items from `Home` by specifying its index.
            spreadsheet.hideToolbarItems('Home', [0, 1, 2, 4, 14, 15, 21, 24]);
            // Set disable state to `Underline`, 'Wrap text` toolbar items from `Home` by specifying the item id.
            spreadsheet.enableToolbarItems('Home', [`${spreadsheet.element.id}_underline`, `${spreadsheet.element.id}_wrap`], false);
            // Set disable state to `Protect Sheet` toolbar item from `Data` by mentioning its index.
            spreadsheet.enableToolbarItems('Data', [0], false);
            // Adding the new `Custom Formulas` toolbar item under `Formulas` tab for adding custom formulas.
            spreadsheet.addToolbarItems('Formulas', [{ type: 'Separator' }, {
                text: 'Custom Formulas', tooltipText: 'Custom Formulas',
                // You can set click handler for each new custom toolbar item
                click: () => {
                    // You can add custom formulas here.
                }
            }]);
            // Adding new custom item `Import` after the existing `Open` item. By default, new item will add after the specified item.
            spreadsheet.addFileMenuItems([{ text: 'Import', iconCss: 'e-open e-icons' }], 'Open');
            // Adding new custom item `Export As` after the existing `Save As` item.
            // Set `insertAfter` optional argument as `false` for adding new item before the specified item.
            spreadsheet.addFileMenuItems([{
                text: 'Export As', iconCss: 'e-save e-icons', items: [{ text: 'XLSX', iconCss: 'e-xlsx e-icons' },
                { text: 'XLS', iconCss: 'e-xls e-icons' }, { text: 'CSV', iconCss: 'e-csv e-icons' }]
            }], 'Save As', false);
        }
    }, []);
    const fileMenuBeforeOpen = () => {
        // Because the file menu items are created dynamically, you need to perform the hide or show and enable/disable operations
        // under filemenu before open event.
        // Hiding the `Save As` and `Open` item.
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.hideFileMenuItems(['Save As', 'Open']);
            // Set disable state to `New` item. You can perform any file menu items customization by specifying the item id,
            // if it has more than one same item text. Set the last argument `isUniqueId` as true for using the item id.
            spreadsheet.enableFileMenuItems([`${spreadsheet.element.id}_New`], false, true);
        }
    };
    const fileMenuItemSelect = (args) => {
        let spreadsheet = spreadsheetRef.current;
        // Custom file menu items select handler
        switch (args.item.text) {
            case 'Import': select(`#${spreadsheet.element.id}_fileUpload`, spreadsheet.element).click();
                break;
            case 'XLSX': if (spreadsheet) { spreadsheet.save({ saveType: 'Xlsx' }) };
                break;
            case 'XLS': if (spreadsheet) { spreadsheet.save({ saveType: 'Xls' }) };
                break;
            case 'CSV': if (spreadsheet) { spreadsheet.save({ saveType: 'Csv' }) };
                break;
            default:
                break;
        }
    };

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} fileMenuBeforeOpen={fileMenuBeforeOpen} fileMenuItemSelect={fileMenuItemSelect}
                showFormulaBar={false} showSheetTabs={false} allowInsert={false} allowDelete={false} allowMerge={false}
                openUrl="https://services.syncfusion.com/react/production/api/spreadsheet/open"
                saveUrl="https://services.syncfusion.com/react/production/api/spreadsheet/save">
                <SheetsDirective>
                    <SheetDirective>
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={180}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={180}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={120}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root'));
root.render(<App />);
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import { SpreadsheetComponent, SheetsDirective, SheetDirective, RangesDirective, RangeDirective, ColumnsDirective, ColumnDirective, MenuSelectEventArgs } from '@syncfusion/ej2-react-spreadsheet';
import { select } from '@syncfusion/ej2-base';
import { data } from './datasource';

function App() {
    const spreadsheetRef = React.useRef<SpreadsheetComponent>(null);
    React.useEffect(() => {
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:F1');
            // Hiding the `Insert` from ribbon.
            spreadsheet.hideRibbonTabs(['Insert']);
            // Set disabled state to `View` ribbon tab.
            spreadsheet.enableRibbonTabs(['View'], false);
            // Adding the `Help` ribbon tab at the last index.
            // Specify the ribbon tab header text in last optional argument(`insertBefore`) for inserting new tab before any existing tab.
            spreadsheet.addRibbonTabs([{
                header: { text: 'Help' }, content: [{
                    text: 'Feedback', tooltipText: 'Feedback',
                    click: (): void => { /* Any click action for this toolbar item will come here. */ }
                }]
            }]);
            // Hiding the unwanted toolbar items from `Home` by specifying its index.
            spreadsheet.hideToolbarItems('Home', [0, 1, 2, 4, 14, 15, 21, 24]);
            // Set disable state to `Underline`, 'Wrap text` toolbar items from `Home` by specifying the item id.
            spreadsheet.enableToolbarItems('Home', [`${spreadsheet.element.id}_underline`, `${spreadsheet.element.id}_wrap`], false);
            // Set disable state to `Protect Sheet` toolbar item from `Data` by mentioning its index.
            spreadsheet.enableToolbarItems('Data', [0], false);
            // Adding the new `Custom Formulas` toolbar item under `Formulas` tab for adding custom formulas.
            spreadsheet.addToolbarItems('Formulas', [{ type: 'Separator' }, {
                text: 'Custom Formulas', tooltipText: 'Custom Formulas',
                // You can set click handler for each new custom toolbar item
                click: (): void => {
                    // You can add custom formulas here.
                }
            }]);
            // Adding new custom item `Import` after the existing `Open` item. By default, new item will add after the specified item.
            spreadsheet.addFileMenuItems([{ text: 'Import', iconCss: 'e-open e-icons' }], 'Open');
            // Adding new custom item `Export As` after the existing `Save As` item.
            // Set `insertAfter` optional argument as `false` for adding new item before the specified item.
            spreadsheet.addFileMenuItems([{
                text: 'Export As', iconCss: 'e-save e-icons', items: [{ text: 'XLSX', iconCss: 'e-xlsx e-icons' },
                { text: 'XLS', iconCss: 'e-xls e-icons' }, { text: 'CSV', iconCss: 'e-csv e-icons' }]
            }], 'Save As', false);
        }
    }, []);
    const fileMenuBeforeOpen = (): void => {
        // Because the file menu items are created dynamically, you need to perform the hide or show and enable/disable operations
        // under filemenu before open event.
        // Hiding the `Save As` and `Open` item.
        let spreadsheet = spreadsheetRef.current;
        if (spreadsheet) {
            spreadsheet.hideFileMenuItems(['Save As', 'Open']);
            // Set disable state to `New` item. You can perform any file menu items customization by specifying the item id,
            // if it has more than one same item text. Set the last argument `isUniqueId` as true for using the item id.
            spreadsheet.enableFileMenuItems([`${spreadsheet.element.id}_New`], false, true);
        }
    };
    const fileMenuItemSelect = (args: MenuSelectEventArgs): void => {
        let spreadsheet = spreadsheetRef.current;
        // Custom file menu items select handler
        switch (args.item.text) {
            case 'Import': select(`#${spreadsheet.element.id}_fileUpload`, spreadsheet.element).click();
                break;
            case 'XLSX': if (spreadsheet) { spreadsheet.save({ saveType: 'Xlsx' }) };
                break;
            case 'XLS': if (spreadsheet) { spreadsheet.save({ saveType: 'Xls' }) };
                break;
            case 'CSV': if (spreadsheet) { spreadsheet.save({ saveType: 'Csv' }) };
                break;
            default:
                break;
        }
    };

    return (
        <div>
            <SpreadsheetComponent ref={spreadsheetRef} fileMenuBeforeOpen={fileMenuBeforeOpen} fileMenuItemSelect={fileMenuItemSelect}
                showFormulaBar={false} showSheetTabs={false} allowInsert={false} allowDelete={false} allowMerge={false}
                openUrl="https://services.syncfusion.com/react/production/api/spreadsheet/open"
                saveUrl="https://services.syncfusion.com/react/production/api/spreadsheet/save">
                <SheetsDirective>
                    <SheetDirective>
                        <RangesDirective>
                            <RangeDirective dataSource={data}></RangeDirective>
                        </RangesDirective>
                        <ColumnsDirective>
                            <ColumnDirective width={180}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={180}></ColumnDirective>
                            <ColumnDirective width={130}></ColumnDirective>
                            <ColumnDirective width={120}></ColumnDirective>
                        </ColumnsDirective>
                    </SheetDirective>
                </SheetsDirective>
            </SpreadsheetComponent>
        </div>
    );
};
export default App;

const root = createRoot(document.getElementById('root')!);
root.render(<App />);
/**
 * Ribbon customization data source
 */
export let data = [
    {
        'Customer Name': 'Romona Heaslip',
        'Model': 'Taurus',
        'Color': 'Aquamarine',
        'Payment Mode': 'Debit Card',
        'Delivery Date': '07/11/2015',
        'Amount': '8529.22'
    },
    {
        'Customer Name': 'Clare Batterton',
        'Model': 'Sparrow',
        'Color': 'Pink',
        'Payment Mode': 'Cash On Delivery',
        'Delivery Date': '7/13/2016',
        'Amount': '17866.19'
    },
    {
        'Customer Name': 'Eamon Traise',
        'Model': 'Grand Cherokee',
        'Color': 'Blue',
        'Payment Mode': 'Net Banking',
        'Delivery Date': '09/04/2015',
        'Amount': '13853.09'
    },
    {
        'Customer Name': 'Julius Gorner',
        'Model': 'GTO',
        'Color': 'Aquamarine',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/15/2017',
        'Amount': '2338.74'
    },
    {
        'Customer Name': 'Jenna Schoolfield',
        'Model': 'LX',
        'Color': 'Yellow',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '10/08/2014',
        'Amount': '9578.45'
    },
    {
        'Customer Name': 'Marylynne Harring',
        'Model': 'Catera',
        'Color': 'Green',
        'Payment Mode': 'Cash On Delivery',
        'Delivery Date': '7/01/2017',
        'Amount': '19141.62'
    },
    {
        'Customer Name': 'Vilhelmina Leipelt',
        'Model': '7 Series',
        'Color': 'Goldenrod',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/20/2015',
        'Amount': '6543.30'
    },
    {
        'Customer Name': 'Barby Heisler',
        'Model': 'Corvette',
        'Color': 'Red',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '11/24/2014',
        'Amount': '13035.06'
    },
    {
        'Customer Name': 'Karyn Boik',
        'Model': 'Regal',
        'Color': 'Indigo',
        'Payment Mode': 'Debit Card',
        'Delivery Date': '05/12/2014',
        'Amount': '18488.80'
    },
    {
        'Customer Name': 'Jeanette Pamplin',
        'Model': 'S4',
        'Color': 'Fuscia',
        'Payment Mode': 'Net Banking',
        'Delivery Date': '12/30/2014',
        'Amount': '12317.04'
    },
    {
        'Customer Name': 'Cristi Espinos',
        'Model': 'TL',
        'Color': 'Aquamarine',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/18/2013',
        'Amount': '6230.13'
    }
];
/**
 * Ribbon customization data source
 */
export let data: Object[] = [
    {
        'Customer Name': 'Romona Heaslip',
        'Model': 'Taurus',
        'Color': 'Aquamarine',
        'Payment Mode': 'Debit Card',
        'Delivery Date': '07/11/2015',
        'Amount': '8529.22'
    },
    {
        'Customer Name': 'Clare Batterton',
        'Model': 'Sparrow',
        'Color': 'Pink',
        'Payment Mode': 'Cash On Delivery',
        'Delivery Date': '7/13/2016',
        'Amount': '17866.19'
    },
    {
        'Customer Name': 'Eamon Traise',
        'Model': 'Grand Cherokee',
        'Color': 'Blue',
        'Payment Mode': 'Net Banking',
        'Delivery Date': '09/04/2015',
        'Amount': '13853.09'
    },
    {
        'Customer Name': 'Julius Gorner',
        'Model': 'GTO',
        'Color': 'Aquamarine',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/15/2017',
        'Amount': '2338.74'
    },
    {
        'Customer Name': 'Jenna Schoolfield',
        'Model': 'LX',
        'Color': 'Yellow',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '10/08/2014',
        'Amount': '9578.45'
    },
    {
        'Customer Name': 'Marylynne Harring',
        'Model': 'Catera',
        'Color': 'Green',
        'Payment Mode': 'Cash On Delivery',
        'Delivery Date': '7/01/2017',
        'Amount': '19141.62'
    },
    {
        'Customer Name': 'Vilhelmina Leipelt',
        'Model': '7 Series',
        'Color': 'Goldenrod',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/20/2015',
        'Amount': '6543.30'
    },
    {
        'Customer Name': 'Barby Heisler',
        'Model': 'Corvette',
        'Color': 'Red',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '11/24/2014',
        'Amount': '13035.06'
    },
    {
        'Customer Name': 'Karyn Boik',
        'Model': 'Regal',
        'Color': 'Indigo',
        'Payment Mode': 'Debit Card',
        'Delivery Date': '05/12/2014',
        'Amount': '18488.80'
    },
    {
        'Customer Name': 'Jeanette Pamplin',
        'Model': 'S4',
        'Color': 'Fuscia',
        'Payment Mode': 'Net Banking',
        'Delivery Date': '12/30/2014',
        'Amount': '12317.04'
    },
    {
        'Customer Name': 'Cristi Espinos',
        'Model': 'TL',
        'Color': 'Aquamarine',
        'Payment Mode': 'Credit Card',
        'Delivery Date': '12/18/2013',
        'Amount': '6230.13'
    }
];

Note

You can refer to our React Spreadsheet feature tour page for its groundbreaking feature representations. You can also explore our React Spreadsheet example to knows how to present and manipulate data.

See Also

Ribbon in Vue Spreadsheet component

16 Mar 202312 minutes to read

It helps to organize a spreadsheet’s features into a series of tabs. By clicking the expand or collapse icon, you can expand or collapse the ribbon toolbar dynamically.

Ribbon Customization

You can customize the ribbon using the following methods,

Method Action
hideRibbonTabs Used to show or hide the existing ribbon tabs.
enableRibbonTabs Used to enable or disable the existing ribbon tabs.
addRibbonTabs Used to add custom ribbon tabs.
hideToolbarItems Used to show or hide the existing ribbon toolbar items.
enableToolbarItems Used to enable or disable the specified toolbar items.
addToolbarItems Used to add the custom items in ribbon toolbar.
hideFileMenuItems Used to show or hide the ribbon file menu items.
enableFileMenuItems Used to enable or disable file menu items.
addFileMenuItems Used to add custom file menu items.

The following code example shows the usage of ribbon customization.

<template>
   <ejs-spreadsheet ref="spreadsheet" :created="created" :fileMenuBeforeOpen="fileMenuBeforeOpen"
                :fileMenuItemSelect="fileMenuItemSelect" :openUrl="openUrl" :saveUrl="saveUrl" :showFormulaBar="false" :showSheetTabs="false" :allowInsert="false" :allowDelete="false" :allowMerge="false">
                <e-sheets>
                  <e-sheet>
                    <e-ranges>
                      <e-range :dataSource="dataSource"></e-range>
                    </e-ranges>
                    <e-columns>
                      <e-column :width=180></e-column>
                      <e-column :width=130></e-column>
                      <e-column :width=130></e-column>
                      <e-column :width=180></e-column>
                      <e-column :width=130></e-column>
                      <e-column :width=120></e-column>
                    </e-columns>
                  </e-sheet>
                </e-sheets>
              </ejs-spreadsheet>
</template>

<script>
import Vue from "vue";
import { SpreadsheetPlugin } from "@syncfusion/ej2-vue-spreadsheet";
import { data } from './data.js';
Vue.use(SpreadsheetPlugin);
export default {
   data: () => {
    return {
      dataSource: data,
      openUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/open';
    saveUrl: 'https://services.syncfusion.com/vue/production/api/spreadsheet/save';
    }
  },
  methods: {
  created: function () {
      var spreadsheet = this.$refs.spreadsheet;
       spreadsheet.cellFormat({ fontWeight: 'bold', textAlign: 'center' }, 'A1:F1');
        // Hiding the `Insert` from ribbon.
        spreadsheet.hideRibbonTabs(['Insert']);
        // Set disabled state to `View` ribbon tab.
        spreadsheet.enableRibbonTabs(['View'], false);
        /// Adding the `Help` ribbon tab at the last index.
        // Specify the ribbon tab header text in last optional argument(`insertBefore`) for inserting new tab before any existing tab.
        spreadsheet.addRibbonTabs([{ header: { text: 'Help' }, content: [{ text: 'Feedback', tooltipText: 'Feedback',
            click : function() { /* Any click action for this toolbar item will come here. */ } }] }]);
        // Hiding the unwanted toobar items from `Home` by specifying its index.
        spreadsheet.hideToolbarItems('Home', [0, 1, 2, 4, 14, 15, 21, 24]);
        // Set diable state to `Underline`, 'Wrap text` toobar items from `Home` by specifying the item id.
        spreadsheet.enableToolbarItems(
            'Home', [`${spreadsheet.ej2Instances.element.id}_underline`, `${spreadsheet.ej2Instances.element.id}_wrap`], false);
        // Set disable state to `Protect Sheet` toolbar item from `Data` by mentioning its index.
        spreadsheet.enableToolbarItems('Data', [0], false);
        // Adding the new `Custom Formulas` toolbar item under `Formulas` tab for adding custom formulas.
        spreadsheet.addToolbarItems(
            'Formulas', [{ type: 'Separator' }, {
                text: 'Custom Formulas', tooltipText: 'Custom Formulas',
                // You can set click handler for each new custom toolbar item
                click: function() {
                    // You can add custom formualas here.
                }
            }]);
        // Adding new custom item `Import` after the existing `Open` item. By default, new item will add after the specified item.
        spreadsheet.addFileMenuItems([{ text: 'Import', iconCss: 'e-open e-icons' }], 'Open');
        // Adding new custom item `Export As` after the existing `Save As` item.
        // Set `insertAfter` optional argument as `false` for adding new item before the specified item.
        spreadsheet.addFileMenuItems(
            [{
                text: 'Export As', iconCss: 'e-save e-icons', items: [{ text: 'XLSX', iconCss: 'e-xlsx e-icons' },
                    { text: 'XLS', iconCss: 'e-xls e-icons' }, { text: 'CSV', iconCss: 'e-csv e-icons' }]
            }],
            'Save As', false);
      },
       fileMenuBeforeOpen: function () {
           var spreadsheet = this.$refs.spreadsheet;
        // Because the file menu items are created dynamically, you need to perform the hide or show and enable/disable operations
        // under filemenu before open event.
        // Hiding the `Save As` and `Open` item.
        spreadsheet.hideFileMenuItems(['Save As', 'Open']);
         // Set disable state to `New` item. You can perform any file menu items customization by specifying the item id,
        // if it has more than one same item text. Set the last argument `isUniqueId` as true for using the item id.
        spreadsheet.enableFileMenuItems([`${spreadsheet.ej2Instances.element.id}_New`], false, true);
    },

    fileMenuItemSelect : function (args) {
        var spreadsheet = this.$refs.spreadsheet;
        // Custom file menu items select handler
        switch (args.item.text) {
            case 'Import': select(`#${spreadsheet.element.id}_fileUpload`, spreadsheet.element).click();
                break;
            case 'XLSX': spreadsheet.save({ saveType: 'Xlsx' });
                break;
            case 'XLS': spreadsheet.save({ saveType: 'Xls' });
                break;
            case 'CSV': spreadsheet.save({ saveType: 'Csv' });
                break;
      }
    }
    }
}
</script>
<style>
 @import "../node_modules/@syncfusion/ej2-vue-spreadsheet/styles/material.css";
 @import '../node_modules/@syncfusion/ej2-base/styles/material.css';  
 @import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';  
 @import '../node_modules/@syncfusion/ej2-dropdowns/styles/material.css';  
 @import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';  
 @import '../node_modules/@syncfusion/ej2-navigations/styles/material.css';
 @import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
 @import '../node_modules/@syncfusion/ej2-splitbuttons/styles/material.css';
 @import '../node_modules/@syncfusion/ej2-grids/styles/material.css';
 @import "../node_modules/@syncfusion/ej2-spreadsheet/styles/material.css";
</style>

Note

You can refer to our Vue Spreadsheet feature tour page for its groundbreaking feature representations. You can also explore our Vue Spreadsheet example to knows how to present and manipulate data.

See Also